//#define _LARGEFILE64_SOURCE
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>

void set8(unsigned char *dest,unsigned long v)
{
	dest[0]=dest[7]=v;
	dest[1]=dest[6]=v>>8;
	dest[2]=dest[5]=v>>16;
	dest[3]=dest[4]=v>>24;
}

void fixiso9660(int fd,int numsectors)
{
int i,j,off;
unsigned char temp[16];
	lseek64(fd,0x8c106ll,SEEK_SET);
	read(fd,temp,4); // sector offset in le
	off=temp[0] | (temp[1]<<8) | (temp[2]<<16) | (temp[3]<<24);
	for(i=0;i<5;++i)
	{
		j=0x7fff0;
		if(numsectors<j+(4-i))
			j=numsectors-(4-i);
		set8(temp,off);
		set8(temp+8,j*2048);
		off+=j;
		numsectors-=j;
		lseek64(fd,0x8c106ll+0x30*i,SEEK_SET);
		write(fd,temp,16);
	}
	lseek64(fd,0x8050ll,SEEK_SET);
	set8(temp,off);
	write(fd,temp,8);
}

int main(int argc,char **argv)
{
int fd;
long long len;

	fd=open(argv[1],O_RDWR|O_LARGEFILE);
	if(fd<0)
	{
		printf("Couldn't open %s\n",argv[1]);
		exit(-1);
	}
	len=lseek64(fd,0ll,SEEK_END);
	fixiso9660(fd,len/2048-473);
	return 0;
}
