#include <sys/time.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include <ctype.h>
#include <stdarg.h>
#include <linux/soundcard.h>
#include <sys/ioctl.h>
#include <SDL.h>

#include "player.h"
#include <libac3/ac3.h>

#define FONTY 13
#define TERMH 5
#define TERMY (YSIZE-50-TERMH*FONTY)
#define RANGEY (YSIZE-48)
#define COURSEY (YSIZE-36)
#define FINEY (YSIZE-20)
#define BARRANGE 6
int playing=0;
int markleft=0;
int markright=0;
int markcenter=-1;
unsigned long playoff=0,scanoff=0;
void moved(void);

#define ENCODING 2

void mainloop(void);
void makeyuvtab(void);
unsigned long globaloff=0,lastglobaloff=0;
int isisofile=0;

int framecounter=0;
int ac3fd=-1;

int done=0;
SDL_Surface *thescreen;
unsigned short *vmem;
int pitch;

int stripanyway=0;

struct inputfile {
int fd;
unsigned long sectors;
} inputfiles[64];
int numinputfiles;

int vobwant=-1;
int loc=0;
int loc2=0;

int oloc=0,oloc2=0;

void trybeep(void)
{
int fd;
int i;
char buf[256];
	if(!getenv("VVBEEP")) return;
	fd=open("/dev/dsp",O_WRONLY);
	if(fd<0) return;
	for(i=0;i<4096;++i)
	{
		buf[i&255]=i*8;
		if((i&255)==255)
			write(fd,buf,256);
	}
	close(fd);
}

// Returns time since started in milliseconds
long long gtime(void)
{
static int firsttimehere=1;
	static struct timeval timeorigin;

	struct timeval now;

	// the first time, set the origin.
	if (firsttimehere) {
		gettimeofday(&timeorigin,NULL);
		firsttimehere=0;
	}

	gettimeofday(&now,NULL);

	return (now.tv_sec-timeorigin.tv_sec)*1000000 +
			(now.tv_usec-timeorigin.tv_usec);
}

int nametail(char *name,char *tail)
{
	if(strlen(name)<strlen(tail)) return -1;
	return strcasecmp(name+strlen(name)-strlen(tail),tail);
}


void setdone(int num)
{
	done=1;
}

long long traffic=0;

int saveframefd=-1;

int getsector(unsigned char *sector,unsigned long num)
{
long long res;
int i;
unsigned long j=0;
struct inputfile *ifile=inputfiles;
	for(i=0;i<numinputfiles;++i,++ifile)
	{
		if(num<j+ifile->sectors) break;
		j+=ifile->sectors;
	}
	if(i==numinputfiles) return -1;
	num-=j;

	res=lseek64(ifile->fd,(long long)num*2048,SEEK_SET);
	if(res<0) {perror("lseek64");return res;}
	res=read(ifile->fd,sector,2048);
	if(res<0) perror("read");
	return res;
}


struct dir {
unsigned char size;
unsigned char pad1;
unsigned long sectorle,sectorbe;
unsigned long lengthle,lengthbe;
unsigned char recordingdate[7];
unsigned char flags;
unsigned char pad2[6];
unsigned char namelength;
char name[128];
} __attribute__ ((packed));
#define MAXRANGES 1024
int numranges=0;
struct range {
unsigned long firstsector;
unsigned long lastsector;
unsigned long sectors;
unsigned char title_key[5];
int id;
} ranges[MAXRANGES];

char *endwant=".VOB;1";

int isvob(struct dir *d)
{
int len;
char *p1,*p2;
int i;
	len=strlen(endwant);
	p1=d->name+d->namelength-len;
	if(p1<d->name) return -1;
	p2=endwant;
	for(i=0;i<len;++i)
	{
		if(tolower(p1[i])!=tolower(p2[i])) return -1;
	}
	if(isdigit(d->name[4]) && isdigit(d->name[5]))
		return 1+atoi(d->name+4);
	return 0;
}
char *rangename(int n)
{
static char name[16];
	if(n==0)
		sprintf(name,"video_ts.vob");
	else
		sprintf(name,"vts_%02d_*.vob",n-1);
	return name;
}


void buildranges(struct dir *d)
{
struct range *r;
int num;
int i;
int size;

	num=isvob(d);
	if(num<0) return;
	for(i=0;i<numranges;++i)
		if(ranges[i].id==num) break;
	r=ranges+i;
	if(i==numranges)
	{
		++numranges;
		r->id=num;
		r->firstsector=0x7fffffff;
		r->lastsector=0;
		r->sectors=0;
	}

	size=(d->lengthle+2047)/2048;
	if(d->sectorle<r->firstsector) r->firstsector=d->sectorle;
	i=d->sectorle+size-1;
	if(i>r->lastsector) r->lastsector=i;
	r->sectors=r->lastsector-r->firstsector+1;

}

int depth=0;
void followdir(struct dir *dir)
{
unsigned char sector[2048];
struct dir *d2;int res;
int count=0;
int offset;
int csector;

	if(depth>12) return;
	++depth;
	csector=dir->sectorle;
top:
	res=getsector(sector,csector++);
	offset=0;
	d2=(void *)sector;
	while(d2->size)
	{
		if(count>=2)
		{
			if(d2->flags & 0x02) followdir(d2);
			else buildranges(d2);
		}
		++count;
		offset+=d2->size;
		if(offset>=2048-0x38) goto top;
		d2=(void *)((unsigned char *)d2 + d2->size);
	}
	--depth;
}

#define BLOCKSIZE (2048)

unsigned long white,black,green;
void clear(void)
{
	memset(thescreen->pixels,0,XSIZE*YSIZE*2);
}
void colordot(int x,int y,int c)
{
	*((unsigned short *)thescreen->pixels+y*thescreen->pitch/2+x)=c;
}
int lockcount;
void scrlock(void)
{
	if(lockcount++) return;
	if(SDL_MUSTLOCK(thescreen))
	{
		if ( SDL_LockSurface(thescreen) < 0 )
		{
			fprintf(stderr, "Couldn't lock display surface: %s\n",
								SDL_GetError());
			return;
		}
	}
}
void scrunlock(void)
{
	if(--lockcount) return;
	SDL_UpdateRect(thescreen, 0, 0, 0, 0);
	if(SDL_MUSTLOCK(thescreen))
		SDL_UnlockSurface(thescreen);
}

unsigned long maprgb(int r,int g,int b)
{
	return SDL_MapRGB(thescreen->format,r,g,b);
}

void drawbar(int val,int y,unsigned long color)
{
int i;
	for(i=0;i<XSIZE;++i)
		colordot(i,y,color);
	for(i=1;i<BARRANGE;++i)
	{
		colordot(val,y-i,color);
		colordot(val,y+i,color);
	}
}

void termstr(char *fmt, ...)
{
char t[512];
va_list ap;
char *p;

	va_start(ap,fmt);
	vsprintf(t,fmt,ap);
	va_end(ap);
	scrlock();
	memmove(vmem+TERMY*pitch,vmem+(TERMY+FONTY)*pitch,2*pitch*(TERMH-1)*FONTY);
	p=t;
	while(*p && *p!='\n') ++p;
	*p=0;
	memset(vmem+(TERMY+(TERMH-1)*FONTY)*pitch,0,pitch*2*FONTY);
	drawstring(3,TERMY+(TERMH-1)*FONTY,t,white);
	scrunlock();
}

int soundid=0x80;
char soundids[256]={0};

void showsoundids(void)
{
char str[256],*p;
int i;
	scrlock();
	p=str;
	p+=sprintf(p,"Sound IDS:");
	for(i=0;i<256;++i)
	{
		if(!soundids[i]) continue;
		p+=sprintf(p," %s%02x",(i==soundid) ? "*" : " ",i);
	}
	drawstring(3,YSIZE-16,str,white);
	scrunlock();
}
void switchsound(void)
{
int i;
	i=soundid;
	do {
		i=(i+1)&0xff;
		if(soundids[i]) break;
	} while(i!=soundid);
	soundid=i;
	showsoundids();
}

#define ABLOCK 16384
unsigned char ac3samples[ABLOCK];
int ac3put=0,ac3take=0;

void ac3fill(unsigned char **start, unsigned char **end)
{
int have;
	have=ac3put-ac3take;
	if(have<0) have+=ABLOCK;
	if(have>ABLOCK-ac3take) have=ABLOCK-ac3take;
	if(have>512) have=512;
	*start=ac3samples+ac3take;
	*end=ac3samples+ac3take+have;
	ac3take+=have;
	if(ac3take==ABLOCK) ac3take=0;
}
ac3_config_t ac3config;
int soundready=0;
int dsp,dsprate=0;
void opensound(void)
{
	if(soundready) return;
	ac3config.fill_buffer_callback=ac3fill;
	ac3config.num_output_ch=2;
	ac3config.flags=0;
	ac3_init(&ac3config);
	soundready=1;
	ac3put=ac3take=0;
	dsp=open("/dev/dsp",O_WRONLY);
	dsprate=0;

}
void closesound(void)
{
	if(!soundready) return;
	close(dsp);
	soundready=0;
}
void configdsp(int rate,int channels)
{
int tmp;
	if(dsprate==rate) return;
	tmp=(channels==2) ? 1 : 0;
	ioctl(dsp,SNDCTL_DSP_STEREO,&tmp);
	tmp=16;
	ioctl(dsp,SNDCTL_DSP_SAMPLESIZE,&tmp);
	tmp=rate;
	ioctl(dsp,SNDCTL_DSP_SPEED,&tmp);
	tmp=(3<<16) | 11;
	ioctl(dsp,SNDCTL_DSP_SETFRAGMENT,&tmp);
	dsprate=rate;
}
void addaudio(unsigned char *p, int l)
{
ac3_frame_t *ac3frame;
int piece;
int have;
	piece=ABLOCK-ac3put;
	if(piece>l) piece=l;
	memcpy(ac3samples+ac3put,p,piece);
	ac3put+=piece;
	if(ac3put==ABLOCK) ac3put=0;
	if(l>piece)
	{
		ac3put=l-piece;
		memcpy(ac3samples,p+piece,ac3put);
	}
	for(;;)
	{
		have=ac3put-ac3take;
		if(have<0) have+=ABLOCK;
		if(have<4096) break;
		ac3frame=ac3_decode_frame();
		configdsp(ac3frame->sampling_rate,2);
		write(dsp,ac3frame->audio_data,256*6*2*2);
	}
}

int handlesound(unsigned char *block,unsigned char *p)
{
int ll;
int len;
int rval;

	ll=p[0]*256+p[1];p+=2;
	p+=2;ll-=2; // skip over 8180 or whatever
	len=1+*p;p+=len;ll-=len;
	if(!soundids[*p])
	{
//		printf("New sound id %02x\n",*p);
		soundids[*p]=1;
		showsoundids();
	}
	if(*p!=soundid) return 0;
	p+=4;
	ll-=4;
//	write(1,p,ll);
	rval=ll;
	if(!playing)
	{
		closesound();
		return rval;
	}
	if(playing!=ENCODING)
	{
		opensound();
		addaudio(p,ll);
	}
	else
//		write(ac3fd,block,BLOCKSIZE);
		write(ac3fd,p,ll);
	return rval;
}

#define STCODE(p,a,b,c,d) ((p)[0] == a && (p)[1] == b && (p)[2] == c && (p)[3] == d)

int soundbytes=0;
int pictures=0;

static inline int isnav(unsigned char *block)
{
	return !block[38] && !block[39] && block[40]==1 && block[41]==0xbf &&
		!block[1024] && !block[1025] && block[1026]==1 && block[1027]==0xbf;
}

void navcheck(unsigned char *block)
{
	if(	0 && isnav(block))
	{
		printf("Sound bytes $%x (%d pieces) pictures %d\n",soundbytes,
			soundbytes/0x7e0,pictures);
		soundbytes=0;
		pictures=0;
	}
}

static unsigned long getpts(unsigned char *p)
{
int c,d,e;
	c=p[0];
	d=p[1]*256+p[2];
	e=p[3]*256+p[4];
	if( ((c&1)!=1) || ((d&1)!=1) || ((e&1)!=1) ){
		printf("ERROR!\n");
	}
	return (((c>>1)&7)<<30)|((d>>1)<<15)|(e>>1);
}

// The PTS is for the entire VOBU, with probably 12 frames. They
// need to be clocked out in order
static void lookforpts(unsigned char *p)
{
unsigned char *t=p+5;
unsigned long pts=0,dts=0;
	if(!(p[3]&0xc0)) return;
	if(p[3]&0x80) {pts=getpts(t);t+=5;} // PTS
	if(p[3]&0x40) {dts=getpts(t);t+=5;} // DTS
printf("%d pictures  ",pictures);pictures=0;
if(pts) printf("pts=%6.2f  ",pts/90000.0);
if(dts) printf("dts=%6.2f",dts/90000.0);
printf("\n");
}

#define BLOCKTYPE_TOSS 0
#define BLOCKTYPE_VIDEO 1
#define BLOCKTYPE_AUDIO 2
#define BLOCKTYPE_NAV 3

unsigned char *lastpes;
int blocktype(unsigned char *block)
{
unsigned char *pes;

	pes= block+14+(block[13]&7);
	if (!pes[0] && !pes[1] && pes[2]==1 && pes[3]==0xbb)
		pes += 6 + (pes[0x04] << 8) + pes[0x05];
	lastpes=pes;
	if (pes[0x00] || pes[0x01] || pes[0x02]!=0x01) return BLOCKTYPE_TOSS;
	if(pes[0x03]==0xbd)
		return BLOCKTYPE_AUDIO;
	if(isnav(block)) return BLOCKTYPE_NAV;
	if((pes[0x03] & 0xf0) == 0xe0) return BLOCKTYPE_VIDEO;
	return BLOCKTYPE_TOSS;
}

long g4(unsigned char *p)
{
	return (*p<<24) | (p[1]<<16) | (p[2]<<8) | p[3];
}

short g2(unsigned char *p)
{
	return (p[2]<<8) | p[3];
}

void play(void)
{
unsigned char block[BLOCKSIZE],*pes;
int len;
int piece;
unsigned long key=~0;
int i;
int bt;
static int angleend=-1,anglenext=0;

	if(playoff>=ranges[vobwant].lastsector)
		playing=0;
	if(!playing)
	{
		angleend=-1;
		return;
	}
	if(playoff==angleend)
	{
printf("angle skip\n");
		playoff=anglenext;
		angleend=-1;
	}
	len=getsector(block,playoff);
	if(len<BLOCKSIZE) return;
	if(isnav(block))
	{
		if(block[0x427]&0x40) // interleaved unit flags, in angle
		{
			angleend=playoff+g4(block+0x429)+1;
			anglenext=playoff+g4(block+0x42d);
			if(anglenext<angleend) anglenext=angleend;
		} else
			angleend=-1;
	}

	++playoff;

	navcheck(block);
	bt=blocktype(block);
	if(bt==BLOCKTYPE_AUDIO)
	{
		soundbytes+=handlesound(block,lastpes+4);
		return;
	}
	if(bt!=BLOCKTYPE_VIDEO) return;

//	lookforpts(lastpes+4);
	pes=lastpes+9+lastpes[8];
	globaloff+=pes-block;
	piece=2048-(pes-block);
	video_add(pes,piece);
	for(i=0;i<piece;++i)
	{
		key=(key<<8) | pes[i];
		if(key==0x100) ++pictures;
	}

}

int savezzz=0;
unsigned char *buildup=0;
unsigned long laststart;
void show1(void)
{
unsigned char block[BLOCKSIZE],*pes;
int len;
int piece;
int fd=-1;
unsigned long sequence=~0;
int i;
int mode=-1;
int lastcode=~0;
int buildin;
int lastbuildin;
int keep;
int bt;
int min,max,center;
	scrlock();
	drawbar(oloc,COURSEY,black);
	drawbar(oloc2+XSIZE/2,FINEY,black);
	oloc=loc;
	oloc2=loc2;
	if(!buildup) buildup=malloc(1000000);
	buildin=lastbuildin=0;

	if(savezzz) fd=open("zzz",O_WRONLY|O_CREAT|O_TRUNC,0644);

	forcecurrentframe=1;
	while(mode<3)
	{
		len=getsector(block,scanoff++);
		if(len<BLOCKSIZE) break;
		bt=blocktype(block);
		if(bt==BLOCKTYPE_TOSS) continue;

		if(mode<0)
		{
			if(bt==BLOCKTYPE_NAV)
			{
				laststart=scanoff-1;
				++mode;
			}
			continue;
		}

		if(bt==BLOCKTYPE_AUDIO)
		{
			handlesound(block,lastpes+4);
			continue;
		}
		if(bt!=BLOCKTYPE_VIDEO) continue;

if(lastpes[0x03]!=0xe0) printf("lastpes[0x03]=%x\n",lastpes[3]);
		pes=lastpes+9+lastpes[8];
		globaloff+=pes-block;
		piece=2048-(pes-block);
		for(i=0;i<piece;++i)
		{
			buildup[buildin++]=pes[i];
			sequence<<=8;
			sequence|=pes[i];
			if((sequence&0xffffff00)!=0x100) continue;
			keep=1;
			if(!mode) keep=0;
			if(keep)
			{
				if(lastcode==0xb3 || lastcode==0xb5 ||
					(lastcode<0xb0 && lastcode>0) ||
					(mode==2 && lastcode==0))
					keep=1;
				else keep=0;
			}
			if(!keep)
			{
				buildin=lastbuildin;
				buildup[buildin++]=0;
				buildup[buildin++]=0;
				buildup[buildin++]=1;
				buildup[buildin++]=sequence;
			} else
			{
				lastbuildin=buildin-4;
				if(lastbuildin<0) lastbuildin=0;
			}
			lastcode=sequence&0xff;
//printf("code=%x, mode=%d\n",sequence,mode);
			if(!mode)
			{
				if(sequence==0x1b3) // sequence start
					++mode;
			} else if(mode==1)
			{
				if(sequence==0x100)
					++mode;
			} else if(mode==2)
			{
				if(sequence==0x1b2) continue; // user data start code
				if((sequence>0x100 && sequence<0x1b0) || sequence==0x1b5)
					continue; // slice start code or extension
				buildin--;
				buildup[buildin++]=0xff;
				buildup[buildin++]=0;
				buildup[buildin++]=0;
				buildup[buildin++]=1;
				buildup[buildin++]=0xff;
				if(savezzz) write(fd,buildup,buildin);
				video_add(buildup,buildin);

				mode=3;
				break;
			}
		}
	}
	if(savezzz) close(fd);
	drawbar(oloc,COURSEY,white);
	drawbar(oloc2+XSIZE/2,FINEY,white);
	min=markleft;
	max=markright;
	if(min<0) min=0;
	if(max<0) max=0;
	i=ranges[vobwant].sectors;
	if(min>=i) min=i-1;
	if(max>=i) max=i-1;
	min=(long long)XSIZE*min/i;
	max=(long long)XSIZE*max/i;
	center=(long long)XSIZE*markcenter/i;
	for(i=0;i<XSIZE;++i)
	{
		if((i&1) && markcenter>=0 && i>center)
			colordot(i,RANGEY,black);
		else
			colordot(i,RANGEY,(i>=min && i<=max) ? green : black);
	}
	scrunlock();
}
void safety(int num)
{
	signal(SIGSEGV,safety);
	printf("Seg fault caught\n");
}

int main(int argc,char **argv)
{
unsigned char *block;
int res;
unsigned char sector[2048];
struct range *r;
unsigned char *chunk;
int i;
unsigned long videoflags;

	signal(SIGINT,setdone);
//	signal(SIGSEGV,safety);

	if(argc<2)
	{
		printf("Specify file(s)\n");
		printf("File can be either an iso image (ends in .iso)\n");
		printf("  If an iso image, you can specify a vob number also\n");
		printf("Or a list of vob files (each end in .vob)\n");
		exit(-1);
	}

	if(!nametail(argv[1],".vob"))
	{
		struct inputfile *ifile=inputfiles;
		for(i=1;i<argc;++i)
		{
			ifile->fd=open(argv[i],O_RDONLY|O_LARGEFILE);
			if(ifile->fd<0)
			{
				printf("Couldn't open file %s\n",argv[i]);
				continue;
			}
			ifile->sectors=lseek64(ifile->fd,0ll,SEEK_END)/2048;
			++ifile;
			++numinputfiles;
		}
		ranges[0].firstsector=0;
		ranges[0].lastsector=0;
		for(i=0;i<numinputfiles;++i)
			ranges[0].lastsector+=inputfiles[i].sectors;
		ranges[0].sectors=ranges[0].lastsector--;
		numranges=1;
		vobwant=0;
	} else
	{
		int fd;
		if(argc>2) vobwant=atoi(argv[2]);
		fd=open(argv[1],O_RDONLY|O_LARGEFILE);
		if(fd<0)
		{
			printf("Couldn't open %s\n",argv[1]);
			exit(-1);
		}
		inputfiles[0].fd=fd;
		inputfiles[0].sectors=lseek64(fd,0ll,SEEK_END)/2048;
		numinputfiles=1;
		isisofile=1;

		res=getsector(sector,16);
		followdir((void *)(sector+0x9c));
		if(argc<3)
		{
			vobwant=0;
			for(i=1;i<numranges;++i)
				if(ranges[i].sectors>ranges[vobwant].sectors)
					vobwant=i;
	
		} else
			vobwant=atoi(argv[2]);
		if(vobwant>=numranges)
		{
			printf("Invalid vob selection %d.\n",vobwant);
			exit(-1);
		}
	}

	for(i=0;i<numranges;++i)
	{
		struct range *r=ranges+i;
		printf("%2d:%s %8lx -%8lx  %10lld\n",i,
			rangename(i),r->firstsector,r->lastsector,
			2048ll*(r->lastsector-r->firstsector));
	}

	printf("*** Displaying VOB set %d ***\n",vobwant);

	if ( SDL_Init(SDL_INIT_VIDEO) < 0 )
	{
		fprintf(stderr, "Couldn't initialize SDL: %s\n",SDL_GetError());
		exit(1);
	}
	videoflags = 0;
	thescreen = SDL_SetVideoMode(XSIZE, YSIZE, 16, videoflags);
	if ( thescreen == NULL )
	{
		fprintf(stderr, "Couldn't set display mode: %s\n",
							SDL_GetError());
		exit(5);
	}
	makeyuvtab();
	vmem=thescreen->pixels;
	pitch=thescreen->pitch/2;

	done=0;
	video_open();

#define NUMBLOCKS 16
	block=chunk=malloc(BLOCKSIZE*NUMBLOCKS);
	r=ranges+vobwant;
	scanoff=r->firstsector;
	loc=0;
	markright=r->sectors;
	moved();
	mainloop();

	video_close();
	return 0;
}

unsigned long *yuvtab;

void makeyuvtab(void)
{
int y,u,v;
int r,g,b;

	white=maprgb(255,255,255);
	black=maprgb(0,0,0);
	green=maprgb(0,255,0);
	yuvtab=malloc(4*0x40*0x40*0x40);
	for(y=0;y<256;y+=4)
		for(u=0;u<256;u+=4)
			for(v=0;v<256;v+=4)
			{
				b=1.164*(y-16)+2.018*(u-128);
				g=1.164*(y-16)-0.813*(v-128)-0.391*(u-128);
				r=1.164*(y-16)+1.596*(v-128);
				if(r<0) r=0;if(r>255) r=255;
				if(g<0) g=0;if(g>255) g=255;
				if(b<0) b=0;if(b>255) b=255;
				yuvtab[(y<<10)|(u<<4)|(v>>2)]=maprgb(r,g,b);
			}
}
static inline unsigned long mapyuv(int y,int u,int v)
{
	return yuvtab[((y&0xfc)<<10)|((u&0xfc)<<4)|((v&0xfc)>>2)];
}

void metronome(void)
{
static long long lasttime=0;
long long now;

#define frameusec (1000*1000000/23997)
//#define frameusec (1000*1000000/30000)
	now=gtime();
	if(now-lasttime>frameusec*3)
	{
printf("too slow\n");
		lasttime=now-frameusec*2;
	}
	while(gtime()<lasttime+1000/24) usleep(10000);
	lasttime+=frameusec;
}

FILE *encp=0;
void newframe(unsigned char *p,int w,int h,int codingtype)
{
int i,j;
int y,u,v;
int w2;
int d;
unsigned char *utab,*vtab;
int fx;
unsigned short *vp;

	if(playing==ENCODING)
	{
		if(!encp)
		{
			encp=popen("mpeg2enc -o /tmp/test.m2v -F 1 -f 8 -a 3 -b 3800","w");
			fprintf(encp,"YUV4MPEG2 W720 H480 F1:1 Ip A0:0\n");
		}
		fprintf(encp,"FRAME\n");
		fwrite(p,1,w*h,encp);
		fwrite(p+w*h+w*h/4,1,w*h/4,encp);
		fwrite(p+w*h,1,w*h/4,encp);

/*
		char name[64];
		int fd;
		sprintf(name,"test%x.yuv",framecounter++ & 15);
		for(;;)
		{
			fd=open(name,O_RDONLY);
			if(fd<0) break;
			close(fd);
			usleep(10000);
		}
		fd=open(name,O_WRONLY|O_CREAT|O_TRUNC,0644);
		write(fd,p,w*h);
		write(fd,p+w*h+w*h/4,w*h/4);
		write(fd,p+w*h,w*h/4);
		close(fd);
*/
	}
	scrlock();
	fx=(XSIZE-w)/2;
	vtab=p+w*h;
	utab=vtab+(w/2*h/2);

	w2=w/2;
	for(j=0;j<h;++j)
	{
		d=(j/2)*w2;
		vp=(unsigned short *)thescreen->pixels+j*thescreen->pitch/2+fx;
		for(i=0;i<w;++i)
		{
			y=p[i+j*w];
			u=utab[d];
			v=vtab[d];
			d+=i&1;

			vp[i]=mapyuv(y,u,v);
		}
	}

//	metronome();
	scrunlock();
}


void moved(void)
{
struct range *r;
long long off;
	r=ranges+vobwant;
	off=loc*XSIZE/2+loc2*4;
	if(off<0) off=0;
	off=r->firstsector+r->sectors*off/(XSIZE*XSIZE/2);
	playoff=scanoff=off;
//video_close();video_open();
	show1();
}

void left1(void)
{
	--loc2;
}
void right1(void)
{
	++loc2;
}

static int rbmin,rbmax,rbkept;
static int anglelow,anglehigh;
int readblocks(unsigned char *buf,int len)
{
int ret,tlen;
int bt;

	ret=0;
	while(len>=BLOCKSIZE && rbmin<rbmax)
	{
		tlen=getsector(buf,rbmin++);
		if(tlen<BLOCKSIZE) break;
		bt=blocktype(buf);
		if(bt==BLOCKTYPE_NAV)
		{
			if(buf[0x427]&0x40) // interleaved unit flags, in angle
			{
				long next,size,at,piece;
				at=rbmin-1;
				size=g4(buf+0x429);
				next=g4(buf+0x42d);
				piece=g4(buf+0x40f);
				memset(buf+0x427,0,10); // get rid of all angle stuff
//printf("%x   %x   %x  %x\n",at,anglelow,anglehigh,piece);
				if(anglelow==-1 || (at>=anglelow && at<=anglehigh))
				{
					anglelow=at;
					anglehigh=at+size;
					if(at+piece==anglehigh)
					{
						if(next==-1) anglelow=anglehigh=0;
						else anglelow=anglehigh=at+next;
					}
				} else
				{
printf("------  angle skip  ------\n");
					rbmin=at+size+1;
					continue;
				}
			} else anglelow=anglehigh=-1;
		}
		if(bt==BLOCKTYPE_AUDIO)
		{
			unsigned char *id;
			id=lastpes+8+lastpes[8]+1;
			if(*id==soundid) *id=0x80;
			else if(*id==0x80) *id=soundid;
		}
		if(stripanyway==2) goto keepit;
		if(!stripanyway && markcenter>=0) goto keepit;
		if(bt==BLOCKTYPE_TOSS) continue;
		if(bt==BLOCKTYPE_AUDIO)
			if(lastpes[8+lastpes[8]+1]!=0x80)
				continue;
keepit:
		buf+=BLOCKSIZE;
		len-=BLOCKSIZE;
		ret+=BLOCKSIZE;
		++rbkept;
	}
	return ret;
}


void export(int doiso,char *savename,int min,int max)
{
unsigned char block[BLOCKSIZE];
int len;
int fd=-1;
struct filelocs thisfl;

	anglelow=anglehigh=-1;
	memset(&thisfl,0,sizeof(thisfl));
	fd=open(savename,O_RDWR|O_CREAT|O_TRUNC|O_LARGEFILE,0644);
	printf("Exporting to file %s\n",savename);
	if(fd<0)
	{
		printf("Couldn't open file %s\n",savename);
		return;
	}
	fl=&thisfl;
	if(doiso)
	{
		fl->fd=fd;
		startudfiso(fl,fd);
	}

	rbmin=min+ranges[vobwant].firstsector;
	rbmax=max+ranges[vobwant].firstsector;
	rbkept=0;

	if(doiso)
	{
		char *argv[16];
		int argc;
		argc=0;
		argv[argc++]="ifogen";
		argv[argc++]="input.vob";
		ifogen_main(argc,argv);
		argc=0;
		argv[argc++]="tocgen";
		argv[argc++]=".";
		tocgen_main(argc,argv);
		fixiso9660(fd);
	} else
	{
		for(;;)
		{
			len=readblocks(block,BLOCKSIZE);
			if(len<BLOCKSIZE) break;
			write(fd,block,BLOCKSIZE);
		}
	}
	printf("Exported file size %lld bytes\n",rbkept*2048ll);
	close(fd);
	trybeep();
}

int icomp(const void *i1,const void *i2)
{
	return *(int *)i1 - *(int *)i2;
}

void count(count)
{
int min,max;
unsigned char block[BLOCKSIZE];
int kept=0;
int len;
int i;
int *tab;

	if(markcenter>=0)
	{
		termstr("Center defined, so no stripping.\n");
		termstr("Range 1 %d sectors %lld bytes\n",markcenter-markleft,
			2048ll*(markcenter-markleft));
		termstr("Range 1 %d sectors %lld bytes\n",markright-markcenter,
			2048ll*(markright-markcenter));
		return;
	}

	min=markleft+ranges[vobwant].firstsector;
	max=markright+ranges[vobwant].firstsector;
#define TRIALS 1000
	tab=malloc(TRIALS*sizeof(int));
	for(i=0;i<TRIALS;++i)
		tab[i]=rand()%(max-min)+min;
	qsort(tab,TRIALS,sizeof(int),icomp);

	for(i=0;i<TRIALS;++i)
	{
		len=getsector(block,tab[i]);
		if(len<BLOCKSIZE)
		{
			printf("Short read at sector %x/%x (%x early)\n",
				min-1,max,max-(min-1));
			break;
		}
		switch(blocktype(block))
		{
		case BLOCKTYPE_TOSS:
			break;
		case BLOCKTYPE_AUDIO:
			if(lastpes[8+lastpes[8]+1]!=soundid) break;
		default:
			++kept;
		}
	}
	termstr("Out of %d trials, %d tossed, %d kept (%5.2f%%)\n",
		TRIALS,TRIALS-kept,kept,100.0*kept/TRIALS);
	termstr("By estimate this range would have %lld bytes\n",
		(max-min)*2048ll*kept/TRIALS);
	free(tab);
}


int processkey(int code,int mod)
{
	switch(code)
	{
	case ' ':
	case 'e':
		playing=!playing;
		if(code=='e')
		{
			playing=ENCODING;
			framecounter=0;
//			system("rm *.yuv");
			ac3fd=open("/tmp/encode.ac3",O_WRONLY|O_CREAT|O_TRUNC,0644);
		}
		if(playing) playoff=laststart;
		else moved();
		break;
	case SDLK_RIGHT:
		right1();
		break;
	case SDLK_LEFT:
		left1();
		break;
	case 'c':
		count();
		break;
	case 'x': // vob image
		export(0,"/tmp/output.vob",markleft,markright);
		break;
	case 'i': // iso image
		if(markcenter<0)
			export(1,VVOUTPUTDIR "/image.iso",markleft,markright);
		else
		{
			export(1,VVOUTPUTDIR "/image.iso",markleft,markcenter);
			export(1,VVOUTPUTDIR "/image2.iso",markcenter,markright);
		}
		break;
	case '3':
	case SDLK_F3:
		if(mod&(KMOD_LSHIFT|KMOD_RSHIFT))
			markleft=0;
		else
			markleft=laststart-ranges[vobwant].firstsector;
		return 1;
	case '4':
	case SDLK_F4:
		if(mod&(KMOD_LSHIFT|KMOD_RSHIFT))
			markright=ranges[vobwant].sectors;
		else
			markright=laststart-ranges[vobwant].firstsector;
		return 1;
	case '5':
	case SDLK_F5:
		if(markcenter<0)
			markcenter=laststart-ranges[vobwant].firstsector;
		else
			markcenter=-1;
		return 1;
	case 'r': // report
		printf("Current sector = %lx\n",laststart-ranges[vobwant].firstsector);
		break;
	case '-': // flip stripanyway
		stripanyway=(stripanyway+1)%3;
		printf("stripanyway=%d, (1=strip anyway, 2=never strip\n",stripanyway);
		break;
	case 's':
		switchsound();
		break;
	case 0x1b:
		done=1;
		break;
	default:
		printf("%d\n",code);
	}
	return 0;
}
int mousex,mousey;
int downx,downy;
int button;

void mainloop(void)
{
SDL_Event event;
int code;
int oldloc=loc;
int oldloc2=loc2;
int force;
int oldp;

	while(!done)
	{
		forcecurrentframe=!playing;
		if(!playing) usleep(10000);
		oldp=playing;
		play();
		if(oldp && !playing) moved();
		force=0;
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
			case SDL_MOUSEBUTTONDOWN:
				button|=1<<event.button.button;
				downx=event.motion.x;
				downy=event.motion.y;
			case SDL_MOUSEMOTION:
				mousex=event.motion.x;
				mousey=event.motion.y;
				if(button && downy>COURSEY-BARRANGE && downy<COURSEY+BARRANGE)
				{
					loc=mousex;
					loc2=0;
					playing=0;
				}
				if(button && downy>FINEY-BARRANGE && downy<FINEY+BARRANGE)
				{
					loc2=mousex-XSIZE/2;
					playing=0;
				}
				break;
			case SDL_MOUSEBUTTONUP:
				button&=~(1<<event.button.button);
				break;
			case SDL_KEYDOWN:
				code=event.key.keysym.sym;
				if(code==SDLK_ESCAPE) done=1;
				force|=processkey(code,event.key.keysym.mod);
				break;
			}
		}
		if(force || oldloc!=loc || oldloc2!=loc2)
		{
			moved();
			oldloc=loc;
			oldloc2=loc2;
		}
	}
}
