
#define FRAME_FIFO_SIZE 32
#define XSIZE 800
#define YSIZE 600

struct filesection
{
	int offset;
	int size;
};

#define VIDEOTSIFO 0
#define VIDEOTSBUP 1
#define VTS01IFO 2
#define VTS01BUP 3
#define VTS01VOB 4
#define INPUTVOB 5

struct filelocs {
	int fd;
	struct filesection fs[20];
};



/* player.c */
extern int nametail(char *name,char *tail);
extern unsigned short *vmem;
extern int toshow;
extern void demux(unsigned char *p,int len);
extern long long gtime(void);
extern long long elapsedtime;
extern int done;
extern void delay(void);
extern int framerate;
extern int current_rate,current_seconds,current_total_seconds;
static inline unsigned long END32(unsigned long val)
{
	return ((val&0xff)<<24) | ((val&0xff00)<<8) |
		 ((val&0xff0000)>>8) | ((val&0xff000000)>>24);
}
extern void newframe(unsigned char *buffer,int width,int height,int codingtype);
extern int readblocks(unsigned char *buf,int len);

/* video.c */
extern void video_open(void);
extern void video_add(unsigned char *data,int len);
extern void video_close(void);
struct vo_frame_s;
extern void player_show_frame(struct vo_frame_s *frame);

/* libmpeg2 */
extern int forcecurrentframe;

/* font.c */
void drawchar(int x,int y,int c,unsigned long color);
void drawstring(int x,int y,char *s,unsigned long color);

/* makeimg.c */
void fixiso9660(int fd);
void startudfiso(struct filelocs *fl,int fd);
int genopen(char *name,int mode, ...);
int genwrite(int fd,void *buf,int len);
int genread(int fd,void *buf,int len);
int genclose(int fd);
long long genseek(int fd,long long off, int mode);
extern struct filelocs *fl;


/* ifogen.c */
int ifogen_main(int argc,char **argv);

/* tocgen.c */
int tocgen_main(int argc,char **argv);
