#include <inttypes.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include "video_out.h"
#include <mpeg2.h>
#include <mm_accel.h>
#include <signal.h>
#include <sys/time.h>
#include <string.h>
#include <math.h>
#include <unistd.h>

#include "player.h"

static mpeg2dec_t mpeg2dec;

extern vo_instance_t *vo_xv_open(void),*vo_null_open(void);
static vo_instance_t *output;

void video_open(void)
{
uint32_t accel;

	accel = mm_accel () | MM_ACCEL_MLIB;
	output=vo_xv_open();
//	output=vo_null_open();
	mpeg2_init(&mpeg2dec, accel, output);
}

void video_add(unsigned char *data,int len)
{
int newframes;

	newframes=mpeg2_decode_data(&mpeg2dec,data,data+len);
}

void video_close(void)
{
	mpeg2_close(&mpeg2dec);
	vo_close(output);
}

int libvo_common_alloc_frames (vo_instance_t * instance, int width, int height,
				   int frame_size,
				   void (* copy) (vo_frame_t *, uint8_t **),
				   void (* field) (vo_frame_t *, int),
				   void (* draw) (vo_frame_t *));
void libvo_common_free_frames (vo_instance_t * instance);
vo_frame_t * libvo_common_get_frame (vo_instance_t * instance, int prediction);

#define MODE_RGB  0x1
#define MODE_BGR  0x2

typedef struct x11_frame_s {
	vo_frame_t vo;
} x11_frame_t;

typedef struct x11_instance_s {
	vo_instance_t vo;
	int prediction_index;
	vo_frame_t * frame_ptr[FRAME_FIFO_SIZE];
	x11_frame_t frame[FRAME_FIFO_SIZE];

	/* local data */
	int width;
	int height;
	int visiblewidth;
	int visibleheight;

	int fc;
} x11_instance_t;


static vo_frame_t * xv_get_frame (vo_instance_t * _instance, int flags)
{
	x11_instance_t * instance;
	x11_frame_t * frame;

	instance = (x11_instance_t *) _instance;

	frame=(x11_frame_t *)instance->frame_ptr[instance->fc];
	++instance->fc;
	instance->fc%=FRAME_FIFO_SIZE;

	return (vo_frame_t *) frame;
}
int framecount=0;
extern long long traffic;
static void xv_append_frame (vo_frame_t * _frame)
{
x11_frame_t *frame;
x11_instance_t * instance;
	frame=(void *)_frame;
	instance = (x11_instance_t *) frame->vo.instance;
	instance->visiblewidth=instance->width;
	instance->visibleheight=instance->height;

	++framecount;

	if(_frame->coding_type==0) return;

	newframe(_frame->base[0],
		instance->width,instance->height,_frame->coding_type);

}


static int alloc_frames (x11_instance_t * instance)
{
	int size;
	uint8_t * alloc;
	int i;

	size = instance->width * instance->height / 4;
	alloc = malloc(FRAME_FIFO_SIZE*6*size);
	if (alloc == NULL)
		return 1;
	memset(alloc,0x80,FRAME_FIFO_SIZE*6*size);

	for (i = 0; i < FRAME_FIFO_SIZE; i++) {
		instance->frame_ptr[i] = (vo_frame_t *) (instance->frame + i);
//		memset(alloc,0,4*size);
//		memset(alloc+4*size,128,2*size);
		instance->frame[i].vo.base[0] = alloc;
		instance->frame[i].vo.base[1] = alloc + 5 * size;
		instance->frame[i].vo.base[2] = alloc + 4 * size;
		instance->frame[i].vo.copy = NULL;
		instance->frame[i].vo.field = NULL;
		instance->frame[i].vo.draw = xv_append_frame;
		instance->frame[i].vo.instance = (vo_instance_t *) instance;
		alloc += 6 * size;
	}

	return 0;
}

static void xv_close (vo_instance_t * _instance)
{
//x11_instance_t * instance = (x11_instance_t *) _instance;

}

static int common_setup (x11_instance_t * instance, int width, int height,
			 int xv)
{
	instance->width = width;
	instance->height = height;

	if (alloc_frames (instance))
		return 1;
	instance->vo.close = xv_close;
	instance->vo.get_frame = xv_get_frame;

	return 0;
}



static int xv_setup (vo_instance_t * instance, int width, int height, 
					 int aspect, int frame_rate, int mpeg1)
{
	return common_setup ((x11_instance_t *) instance, width, height, 1);
}

vo_instance_t * vo_xv_open (void)
{
	x11_instance_t * instance;

	instance = malloc (sizeof (x11_instance_t));
	if (instance == NULL)
		return NULL;
	memset(instance,0,sizeof(x11_instance_t));

	instance->vo.setup = xv_setup;
	return (vo_instance_t *) instance;
}

void initinput(void)
{
}

void scaninput(void)
{
}
